#!/bin/sh
# Copyright (C)2003..2007 @BABOLO
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: test.sh,v 1.8 2007/07/20 20:23:43 babolo Exp $

PREFIX=/usr/local

case $1 in
@0@)
    shift
    echo s0
    3<<- "EOF"
	argc=2 ==============
	   0 ~#~
	   1 ~test~
	argc=3 ==============
	   0 ~a~
	   1 ~fg~
	   2 ~23~
	argc=3 ==============
	   0 ~a~
	   1 ~fg~
	   2 ~23#@%^~
	argc=2 ==============
	   0 ~%	$~
	   1 ~S~
	argc=4 ==============
	   0 ~\045\301\011~
	   1 ~ ~
	   2 ~ 	~
	   3 ~--comment~
	argc=0 ==============
	argc=3 ==============
	   0 ~tu~
	   1 ~tu~
	   2 ~tutututu
	~
	argc=1 ==============
	   0 ~test
	~
	argc=1 ==============
	   0 ~\
	test~
	EOF
    env TU=tu ./tools/test $1 ./tools/testln.tst '' | diff -u /dev/fd/0 /dev/fd/3
    echo s0x200
    4<<- "EOF"
	argc=2 ==============
	   0 ~#~
	   1 ~test~
	argc=3 ==============
	   0 ~a~
	   1 ~fg~
	   2 ~23~
	argc=4 ==============
	   0 ~~
	   1 ~a~
	   2 ~fg~
	   3 ~23#@%^~
	argc=2 ==============
	   0 ~%	$~
	   1 ~S~
	argc=4 ==============
	   0 ~\045\301\011~
	   1 ~ ~
	   2 ~ 	~
	   3 ~--comment~
	argc=0 ==============
	argc=3 ==============
	   0 ~tu~
	   1 ~tu~
	   2 ~tutututu
	~
	argc=1 ==============
	   0 ~test
	~
	argc=1 ==============
	   0 ~\
	test~
	EOF
    env TU=tu ./tools/test -s0x200 $1 ./tools/testln.tst '' | diff -u /dev/fd/0 /dev/fd/4
    echo s0x400
    5<<- "EOF"
	argc=2 ==============
	   0 ~#~
	   1 ~test~
	argc=3 ==============
	   0 ~a~
	   1 ~fg~
	   2 ~23~
	argc=3 ==============
	   0 ~a~
	   1 ~fg~
	   2 ~23#@%^~
	argc=2 ==============
	   0 ~%	$~
	   1 ~S~
	argc=4 ==============
	   0 ~\045\301\011~
	   1 ~ ~
	   2 ~ 	~
	   3 ~--comment~
	argc=0 ==============
	argc=3 ==============
	   0 ~$TU~
	   1 ~$TU~
	   2 ~$TU$TU$TU${TU}
	~
	argc=1 ==============
	   0 ~test
	~
	argc=1 ==============
	   0 ~\
	test~
	EOF
    env TU=tu ./tools/test -s0x400 $1 ./tools/testln.tst '' | diff -u /dev/fd/0 /dev/fd/5
    echo s0x600
    6<<- "EOF"
	argc=2 ==============
	   0 ~#~
	   1 ~test~
	argc=3 ==============
	   0 ~a~
	   1 ~fg~
	   2 ~23~
	argc=4 ==============
	   0 ~~
	   1 ~a~
	   2 ~fg~
	   3 ~23#@%^~
	argc=2 ==============
	   0 ~%	$~
	   1 ~S~
	argc=4 ==============
	   0 ~\045\301\011~
	   1 ~ ~
	   2 ~ 	~
	   3 ~--comment~
	argc=0 ==============
	argc=3 ==============
	   0 ~$TU~
	   1 ~$TU~
	   2 ~$TU$TU$TU${TU}
	~
	argc=1 ==============
	   0 ~test
	~
	argc=1 ==============
	   0 ~\
	test~
	EOF
    env TU=tu ./tools/test -s0x600 $1 ./tools/testln.tst '' | diff -u /dev/fd/0 /dev/fd/6
    echo z
    7<<- "EOF"
	argc=19 ==============
	   0 ~#~
	   1 ~test~
	   2 ~a~
	   3 ~fg~
	   4 ~23~
	   5 ~a~
	   6 ~fg~
	   7 ~23#@%^~
	   8 ~%	$~
	   9 ~S~
	  10 ~\045\301\011~
	  11 ~ ~
	  12 ~ 	~
	  13 ~--comment~
	  14 ~tu~
	  15 ~tu~
	  16 ~tutututu
	~
	  17 ~test
	~
	  18 ~\
	test~
	EOF
    env TU=tu ./tools/test $1 ./tools/testln.tst | diff -u /dev/fd/0 /dev/fd/7
    echo s0x02
    8<<- "EOF"
	argc=2 ==============
	   0 ~#~
	   1 ~test~
	argc=2 ==============
	   0 ~a~
	   1 ~fg 23~
	argc=2 ==============
	   0 ~a~
	   1 ~fg 23#@%^~
	argc=2 ==============
	   0 ~%	$~
	   1 ~S~
	argc=2 ==============
	   0 ~\045\301\011~
	   1 ~   	 --comment~
	argc=0 ==============
	argc=2 ==============
	   0 ~tu~
	   1 ~tu tutututu
	~
	argc=1 ==============
	   0 ~test
	~
	argc=1 ==============
	   0 ~\
	test~
	EOF
    env TU=tu ./tools/test -s0x02 $1 ./tools/testln.tst '' | diff -u /dev/fd/0 /dev/fd/8
    echo '#'
    9<<- "EOF"
	argc=0 ==============
	argc=7 ==============
	   0 ~test~
	   1 ~a~
	   2 ~fg~
	   3 ~23~
	   4 ~a~
	   5 ~fg~
	   6 ~23~
	argc=12 ==============
	   0 ~@%^~
	   1 ~%	$~
	   2 ~S~
	   3 ~\045\301\011~
	   4 ~ ~
	   5 ~ 	~
	   6 ~--comment~
	   7 ~tu~
	   8 ~tu~
	   9 ~tutututu
	~
	  10 ~test
	~
	  11 ~\
	test~
	EOF
    env TU=tu ./tools/test ./tools/testln.tst '#' | diff -u /dev/fd/0 /dev/fd/9
    ;;
@1@)
    shift
    echo 's0x4000 #'
    3<<- "EOF"
	argc=0 ==============
	argc=3 ==============
	   0 ~a~
	   1 ~fg~
	   2 ~23~
	argc=3 ==============
	   0 ~a~
	   1 ~fg~
	   2 ~23~
	argc=2 ==============
	   0 ~%	$~
	   1 ~S~
	argc=4 ==============
	   0 ~\045\301\011~
	   1 ~ ~
	   2 ~ 	~
	   3 ~--comment~
	argc=0 ==============
	argc=3 ==============
	   0 ~tu~
	   1 ~tu~
	   2 ~tutututu
	~
	argc=1 ==============
	   0 ~test
	~
	argc=1 ==============
	   0 ~\
	test~
	EOF
    env TU=tu ./tools/test -s0x4000 $1 ./tools/testln.tst '#' | diff -u /dev/fd/0 /dev/fd/3
    echo 's0x4000 --'
    4<<- "EOF"
	argc=2 ==============
	   0 ~#~
	   1 ~test~
	argc=3 ==============
	   0 ~a~
	   1 ~fg~
	   2 ~23~
	argc=3 ==============
	   0 ~a~
	   1 ~fg~
	   2 ~23#@%^~
	argc=2 ==============
	   0 ~%	$~
	   1 ~S~
	argc=3 ==============
	   0 ~\045\301\011~
	   1 ~ ~
	   2 ~ 	~
	argc=0 ==============
	argc=3 ==============
	   0 ~tu~
	   1 ~tu~
	   2 ~tutututu
	~
	argc=1 ==============
	   0 ~test
	~
	argc=1 ==============
	   0 ~\
	test~
	EOF
    env TU=tu ./tools/test -s0x4000 $1 ./tools/testln.tst '--' | diff -u /dev/fd/0 /dev/fd/4
    ;;
@2@)
    shift
    F=${1}
    shift

    for i in 1 2 3 4; do
        lexor -pipe -Wall -I${PREFIX}/include -o ${F}/t${i}.h ./tools/test${i}.lexor
    done
    cc -pipe -Wall -I${PREFIX}/include -L${PREFIX}/lib -lmife -lbabolo-parser -o ${F}/t ${F}/t.c

    echo "lexor (0x10000)"
    3<<- "EOF"
	    0     1         0
	    1     1         0
	    2     2         1
	    3     6         2
	    4     6         0
	    5     4         0
	    6     5         3
	    7     4         4
	    8     3         4
	    9     3         4
	   10     3         0
	   11     6         5
	   12     6         6
	   13     6         7
	   14     1         0
	EOF
    ${F}/t -s0x10000 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/3

    echo "lexor -a2 (0x10000)"
    4<<- "EOF"
	    0     1         0
	    1     1         0
	    2     2       256
	    3     6       512
	    4     6         0
	    5     4         0
	    6     5       768
	    7     4      1024
	    8     3      1024
	    9     3      1024
	   10     3         0
	   11     6      1280
	   12     6      1536
	   13     6      1792
	   14     1         0
	EOF
    ${F}/t -a2 -s0x10000 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/4

    echo "lexor -a3 (0x10000)"
    5<<- "EOF"
	    0     1         0
	    1     1         0
	    2     2     65536
	    3     6    131072
	    4     6         0
	    5     4         0
	    6     5    196608
	    7     4    262144
	    8     3    262144
	    9     3    262144
	   10     3         0
	   11     6    327680
	   12     6    393216
	   13     6    458752
	   14     1         0
	EOF
    ${F}/t -a3 -s0x10000 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/5

    echo "lexor -a4 (0x10000)"
    6<<- "EOF"
	    0     1         0
	    1     1         0
	    2     2  16777216
	    3     6  33554432
	    4     6         0
	    5     4         0
	    6     5  50331648
	    7     4  67108864
	    8     3  67108864
	    9     3  67108864
	   10     3         0
	   11     6  83886080
	   12     6 100663296
	   13     6 117440512
	   14     1         0
	EOF
    ${F}/t -a4 -s0x10000 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/6
    ;;
@3@)
    shift
    F=${1}
    shift

    for i in 1 2 3 4; do
        lexor -f -pipe -Wall -I${PREFIX}/include -o ${F}/t${i}.h ./tools/test${i}.lexor
    done
    cc -pipe -Wall -I${PREFIX}/include -L${PREFIX}/lib -lmife -lbabolo-parser -o ${F}/t ${F}/t.c

    echo "lexor -f (0x10000)"
    3<<- "EOF"
	    0     1         0
	    1     1         0
	    2     2         1
	    3     6         2
	    4     6         0
	    5     4         0
	    6     5         3
	    7     4         4
	    8     3         4
	    9     3         4
	   10     3         0
	   11     6         5
	   12     6         6
	   13     6         7
	   14     1         0
	EOF
    ${F}/t -s0x10000 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/3

    echo "lexor -f -a2 (0x10000)"
    4<<- "EOF"
	    0     1         0
	    1     1         0
	    2     2       256
	    3     6       512
	    4     6         0
	    5     4         0
	    6     5       768
	    7     4      1024
	    8     3      1024
	    9     3      1024
	   10     3         0
	   11     6      1280
	   12     6      1536
	   13     6      1792
	   14     1         0
	EOF
    ${F}/t -a2 -s0x10000 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/4

    echo "lexor -f -a3 (0x10000)"
    5<<- "EOF"
	    0     1         0
	    1     1         0
	    2     2     65536
	    3     6    131072
	    4     6         0
	    5     4         0
	    6     5    196608
	    7     4    262144
	    8     3    262144
	    9     3    262144
	   10     3         0
	   11     6    327680
	   12     6    393216
	   13     6    458752
	   14     1         0
	EOF
    ${F}/t -a3 -s0x10000 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/5

    echo "lexor -f -a4 (0x10000)"
    6<<- "EOF"
	    0     1         0
	    1     1         0
	    2     2  16777216
	    3     6  33554432
	    4     6         0
	    5     4         0
	    6     5  50331648
	    7     4  67108864
	    8     3  67108864
	    9     3  67108864
	   10     3         0
	   11     6  83886080
	   12     6 100663296
	   13     6 117440512
	   14     1         0
	EOF
    ${F}/t -a4 -s0x10000 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/6
    ;;
@4@)
    shift
    F=${1}
    shift

    for i in 1 2 3 4; do
        lexor -pipe -Wall -I${PREFIX}/include -o ${F}/t${i}.h ./tools/test${i}.lexor
    done
    cc -pipe -Wall -I${PREFIX}/include -L${PREFIX}/lib -lmife -lbabolo-parser -o ${F}/t ${F}/t.c

    echo "lexor"
    3<<- "EOF"
	    0     0         0
	    0     1
	    1     1         0
	    2     2         1
	    3     6         2
	    4     5         0
	    5     5         3
	    6     5         3
	    7     3         4
	    8     0         0
	    8     1
	    9     3         4
	   10     3         4
	   11     2         0
	   12     0         0
	   12     1
	   13     6         5
	   14     6         6
	   15     6         7
	   16     1         0
	EOF
    ${F}/t $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/3

    echo "lexor -a2"
    4<<- "EOF"
	    0     0         0
	    0     1
	    1     1         0
	    2     2       256
	    3     6       512
	    4     5         0
	    5     5       768
	    6     5       768
	    7     3      1024
	    8     0         0
	    8     1
	    9     3      1024
	   10     3      1024
	   11     2         0
	   12     0         0
	   12     1
	   13     6      1280
	   14     6      1536
	   15     6      1792
	   16     1         0
	EOF
    ${F}/t -a2 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/4

    echo "lexor -a3"
    5<<- "EOF"
	    0     0         0
	    0     1
	    1     1         0
	    2     2     65536
	    3     6    131072
	    4     5         0
	    5     5    196608
	    6     5    196608
	    7     3    262144
	    8     0         0
	    8     1
	    9     3    262144
	   10     3    262144
	   11     2         0
	   12     0         0
	   12     1
	   13     6    327680
	   14     6    393216
	   15     6    458752
	   16     1         0
	EOF
    ${F}/t -a3 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/5

    echo "lexor -a4"
    6<<- "EOF"
	    0     0         0
	    0     1
	    1     1         0
	    2     2  16777216
	    3     6  33554432
	    4     5         0
	    5     5  50331648
	    6     5  50331648
	    7     3  67108864
	    8     0         0
	    8     1
	    9     3  67108864
	   10     3  67108864
	   11     2         0
	   12     0         0
	   12     1
	   13     6  83886080
	   14     6 100663296
	   15     6 117440512
	   16     1         0
	EOF
    ${F}/t -a4 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/6
    ;;
@5@)
    shift
    F=${1}
    shift

    for i in 1 2 3 4; do
        lexor -f -pipe -Wall -I${PREFIX}/include -o ${F}/t${i}.h ./tools/test${i}.lexor
    done
    cc -pipe -Wall -I${PREFIX}/include -L${PREFIX}/lib -lmife -lbabolo-parser -o ${F}/t ${F}/t.c

    echo "lexor -f"
    3<<- "EOF"
	    0     0         0
	    0     1
	    1     1         0
	    2     2         1
	    3     6         2
	    4     5         0
	    5     5         3
	    6     5         3
	    7     3         4
	    8     0         0
	    8     1
	    9     3         4
	   10     3         4
	   11     2         0
	   12     0         0
	   12     1
	   13     6         5
	   14     6         6
	   15     6         7
	   16     1         0
	EOF
    ${F}/t $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/3

    echo "lexor -f -a2"
    4<<- "EOF"
	    0     0         0
	    0     1
	    1     1         0
	    2     2       256
	    3     6       512
	    4     5         0
	    5     5       768
	    6     5       768
	    7     3      1024
	    8     0         0
	    8     1
	    9     3      1024
	   10     3      1024
	   11     2         0
	   12     0         0
	   12     1
	   13     6      1280
	   14     6      1536
	   15     6      1792
	   16     1         0
	EOF
    ${F}/t -a2 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/4

    echo "lexor -f -a3"
    5<<- "EOF"
	    0     0         0
	    0     1
	    1     1         0
	    2     2     65536
	    3     6    131072
	    4     5         0
	    5     5    196608
	    6     5    196608
	    7     3    262144
	    8     0         0
	    8     1
	    9     3    262144
	   10     3    262144
	   11     2         0
	   12     0         0
	   12     1
	   13     6    327680
	   14     6    393216
	   15     6    458752
	   16     1         0
	EOF
    ${F}/t -a3 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/5

    echo "lexor -f -a4"
    6<<- "EOF"
	    0     0         0
	    0     1
	    1     1         0
	    2     2  16777216
	    3     6  33554432
	    4     5         0
	    5     5  50331648
	    6     5  50331648
	    7     3  67108864
	    8     0         0
	    8     1
	    9     3  67108864
	   10     3  67108864
	   11     2         0
	   12     0         0
	   12     1
	   13     6  83886080
	   14     6 100663296
	   15     6 117440512
	   16     1         0
	EOF
    ${F}/t -a4 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/6
    ;;
@6@)
    shift
    F=${1}
    shift

    echo "lexor -a0 (0x10000)"
    3<<- "EOF"
	    0     2         0
	    1     8         0
	    2    10         1
	    3     8         1
	    4     4         1
	    5     9         1
	    6     3         2
	    7     9         1
	    8     3         4
	    9     1         0
	EOF
    ${F}/t -a0 -s0x10000 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/3

    echo "lexor -a0"
    4<<- "EOF"
	    0     2         0
	    1     8         0
	    2    10         1
	    3     8         1
	    4     4         1
	    5     9         1
	    6     3         2
	    7     9         1
	    8     3         4
	    9     1         0
	EOF
    ${F}/t -a0 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/4

    echo "lexor -a0 (0x40000)"
    5<<- "EOF"
	    0     0         0
	    0     1
	    1     1         0
	    2     1         0
	    3     0         0
	    3     1
	    4     6         0
	    5     9         0
	    6     0         0
	    6     1
	    7     5         1
	    8     2         0
	    9     0         0
	    9     1
	   10     0         0
	   10     1
	   11     2         0
	   12     0         0
	   12     1
	   13     2         0
	   14     0         0
	   14     1
	   15     3         3
	   16     2         0
	   17     0         0
	   17     1
	   18     3         2
	   19     2         0
	   20     0         0
	   20     1
	   21     2         0
	   22     0         0
	   22     1
	   23     2         0
	   24     0         0
	   24     1
	   25     3         4
	   26     1         0
	EOF
    ${F}/t -a0 -s0x40000 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/5

    echo "lexor -a0 (0x50000)"
    6<<- "EOF"
	    0     0         0
	    0     1
	    1     1         0
	    2     1         0
	    3     0         0
	    3     1
	    4     6         0
	    5     9         0
	    6     0         0
	    6     1
	    7     5         1
	    8     2         0
	    9     0         0
	    9     1
	   10     0         0
	   10     1
	   11     2         0
	   12     0         0
	   12     1
	   13     2         0
	   14     0         0
	   14     1
	   15     3         3
	   16     2         0
	   17     0         0
	   17     1
	   18     3         2
	   19     2         0
	   20     0         0
	   20     1
	   21     2         0
	   22     0         0
	   22     1
	   23     2         0
	   24     0         0
	   24     1
	   25     3         4
	   26     1         0
	EOF
    ${F}/t -a0 -s0x50000 $1 < ./tools/words | diff -u /dev/fd/0 /dev/fd/6
    ;;
*)
    $0 '@0@' "$@"
    $0 '@1@' "$@"
    F=`mktemp -d -t lexor.test`
    sed -e "s|@@INCLUDELEXOR@@|${F}|" ./tools/texot > ${F}/t.c
    $0 '@2@' ${F} "$@"
    $0 '@3@' ${F} "$@"
    $0 '@4@' ${F} "$@"
    $0 '@5@' ${F} "$@"
    $0 '@6@' ${F} "$@"
    rm -rf ${F}
esac
